#include <windows.h>

#define JANUSHSEXE "JanusHS.exe"

/*------------------------------------------------------------*/
int WINAPI
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
  LPSTR p, p0;
  LPSTR lpCmdLine2;
  CHAR lpApplicationName[MAX_PATH + 1 + 2];
  PROCESS_INFORMATION pi;
  STARTUPINFO si;

  ZeroMemory(&si,sizeof(si));
  si.cb=sizeof(si);

  lpApplicationName[0] = '"';
  if (!GetModuleFileName(NULL, lpApplicationName + 1, MAX_PATH)) {
    MessageBox(NULL, "Failed", "Error", MB_OK);
    return 1;
  }
  for (p = lpApplicationName + 1, p0 = p; *p; p++) {
    if (*p == '\\') p0 = p;
    if (IsDBCSLeadByte(*p)) p++;
  }
  *(p0 + 1) = '\0';
  lstrcat(lpApplicationName, JANUSHSEXE);
  lstrcat(lpApplicationName, "\"");

  lpCmdLine2 = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, 5 + lstrlen(lpApplicationName) + lstrlen(lpCmdLine));
  if (!lpCmdLine2) {
    MessageBox(NULL, "Out of memory", "Error", MB_OK);
    return 1;
  }
  lstrcpy(lpCmdLine2, lpApplicationName);
  lstrcat(lpCmdLine2, " -d ");
  lstrcat(lpCmdLine2, lpCmdLine);
  if (!CreateProcess(NULL, lpCmdLine2, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi)) {
    MessageBox(NULL, "Failed to execute application", "ERROR", MB_OK);
    return 1;
  }
  CloseHandle(pi.hThread);
  CloseHandle(pi.hProcess);
  HeapFree(GetProcessHeap(), 0, lpCmdLine2);
  return 0;
}

/*------------------------------------------------------------*/
 
